---
title: DOMImplementation
slug: Web/API/DOMImplementation
tags:
  - API
  - DOM
  - Interface
  - Reference
---
<p>{{ ApiRef("DOM") }}</p>

<p>The <code><strong>DOMImplementation</strong></code> interface represents an object providing methods which are not dependent on any particular document. Such an object is returned by the {{domxref("Document.implementation")}} property.</p>

<h2 id="Property">Property</h2>

<p><em>This interface has no specific property and doesn't inherit any.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>No inherited method.</em></p>

<dl>
 <dt>{{domxref("DOMImplementation.createDocument()")}}</dt>
 <dd>Creates and returns an {{domxref("XMLDocument")}}.</dd>
 <dt>{{domxref("DOMImplementation.createDocumentType()")}}</dt>
 <dd>Creates and returns a {{domxref("DocumentType")}}.</dd>
 <dt>{{domxref("DOMImplementation.createHTMLDocument()")}}</dt>
 <dd>Creates and returns an HTML {{domxref("Document")}}.</dd>
 <dt>{{domxref("DOMImplementation.hasFeature()")}}</dt>
 <dd>Returns a {{domxref("Boolean")}} indicating if a given feature is supported or not. This function is unreliable and kept for compatibility purpose alone: except for SVG-related queries, it always returns <code>true</code>. Old browsers are very inconsistent in their behavior.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#domimplementation', 'DOMImplementation')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Removed the <code>getFeature()</code> method.<br>
    Added the <code>createHTMLDocument()</code> method.<br>
    Modified the return type of <code>createDocument()</code> from {{domxref("Document")}} to {{domxref("XMLDocument")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-102161490', 'DOMImplementation')}}</td>
   <td>{{Spec2('DOM3 Core')}}</td>
   <td>Added the <code>getFeature()</code> method (never implemented by any user agent).</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-102161490', 'DOMImplementation')}}</td>
   <td>{{Spec2('DOM2 Core')}}</td>
   <td>Added the <code>createDocument()</code> and <code>createDocumentType()</code> methods.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-core.html#ID-102161490', 'DOMImplementation')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMImplementation")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index.</a></li>
</ul>
